import UIKit
import SDWebImage
import UIView_Shimmer

class ChatTableItem: UITableViewCell, ShimmeringViewProtocol {
    
    @IBOutlet weak var timeLabel: UILabel!
    @IBOutlet weak var lastMessageLabel: UILabel!
    @IBOutlet weak var usernameLabel: UILabel!
    @IBOutlet weak var profileImage: UIImageView!
    @IBOutlet weak var countLabel: UILabel!
    @IBOutlet weak var countView: UIView!
    
    var shimmeringAnimatedItems: [UIView] {
        [
            timeLabel,
            lastMessageLabel,
            usernameLabel,
            profileImage,
            countLabel,
            countView
        ]
    }
    
    override func awakeFromNib() {
        super.awakeFromNib()
        // Initialization code
    }
    
    override func setSelected(_ selected: Bool, animated: Bool) {
        super.setSelected(selected, animated: animated)
        
        // Configure the view for the selected state
    }
    
    func bind(_ object: ChatModel.Datum) {
        let profileImage = URL(string: object.user?.avatar ?? "")
        self.profileImage.sd_setShowActivityIndicatorView(true)
        self.profileImage.sd_setIndicatorStyle(.medium)
        DispatchQueue.global(qos: .userInteractive).async {
            self.profileImage.sd_setImage(with: profileImage , placeholderImage:R.image.maxresdefault())
        }
        if object.user?.name?.isEmpty ?? false {
            self.usernameLabel.text = object.user?.username ?? ""
        } else {
            self.usernameLabel.text = object.user?.name ?? ""
        }
        self.lastMessageLabel.text = object.get_last_message?.text ?? ""
        self.timeLabel.text = object.text_time ?? ""
        if object.get_count_seen != 0 {
            self.countView.isHidden = false
            self.countLabel.text = String(object.get_count_seen ?? 0)
        } else {
            self.countView.isHidden = true
        }
    }
    
}
