//
//  LiveTableViewCell.swift
//  Playtube
//
//  Created by Abdul Moid on 29/03/2021.
//  Copyright © 2021 Muhammad Haris Butt. All rights reserved.
//

import UIKit

class LiveTableViewCell: UITableViewCell {
    
    // MARK: - IBOutlets

    @IBOutlet weak var commentLabel: UILabel!
    @IBOutlet weak var profileImageView: UIImageView!
    @IBOutlet weak var usernameLabel: UILabel!
    
    // MARK: - Initialize Functions
    
    override func awakeFromNib() {
        super.awakeFromNib()
        
        self.initialConfig()
    }

    override func setSelected(_ selected: Bool, animated: Bool) {
        super.setSelected(selected, animated: animated)

        // Configure the view for the selected state
    }
    
    // MARK: - Helper Functions
    
    // Initial Config
    func initialConfig() {
        self.setupUI()
    }
    
    // Setup UI
    func setupUI() {
        
    }
    
    // Set Data
    func setData(comment: Comment) {
        let profileImage = URL(string: comment.commentUserData?.avatar ?? "")
        self.profileImageView.sd_setShowActivityIndicatorView(true)
        self.profileImageView.sd_setIndicatorStyle(.medium)
        DispatchQueue.global(qos: .userInteractive).async {
            self.profileImageView.sd_setImage(with: profileImage , placeholderImage: R.image.maxresdefault())
        }
        self.usernameLabel.text = comment.commentUserData?.name
        self.commentLabel.text = comment.text
    }
    
}
