//
//  AgoraExtensions.swift
//  Playtube
//
//  Created by iMac on 29/01/24.
//  Copyright © 2024 ScriptSun. All rights reserved.
//

import Foundation
import AgoraRtcKit

extension AgoraErrorCode {
    
    var description: String {
        var text: String
        switch self {
        case .joinChannelRejected:  text = "join channel rejected"
        case .leaveChannelRejected: text = "leave channel rejected"
        case .invalidAppId:         text = "invalid app id"
        case .invalidToken:         text = "invalid token"
        case .invalidChannelId:     text = "invalid channel id"
        default:                    text = "\(self.rawValue)"
        }
        return text
    }
    
}

extension AgoraWarningCode {
    
    var description: String {
        var text: String
        switch self {
        case .invalidView: text = "invalid view"
        default:           text = "\(self.rawValue)"
        }
        return text
    }
    
}
