//
//  EndAudienceLiveStreamVC.swift
//  Playtube
//
//  Created by iMac on 30/01/24.
//  Copyright © 2024 ScriptSun. All rights reserved.
//

import UIKit
import SDWebImage

protocol EndAudienceLiveStreamVCDelegate {
    func handleDismissEndAudienceLiveStream()
    func handleGoLiveButtonAction()
}

class EndAudienceLiveStreamVC: UIViewController {
    
    // MARK: - IBOutlets
    
    @IBOutlet weak var userImageView: UIImageView!
    
    // MARK: - Properties
    
    var videoDetail: VideoDetail?
    var delegate: EndAudienceLiveStreamVCDelegate?
    
    // MARK: - View Life Cycles

    override func viewDidLoad() {
        super.viewDidLoad()

        // Do any additional setup after loading the view.
        
        self.initialConfig()
    }
    
    // MARK: - Selectors
    
    // Close Button Action
    @IBAction func closeButtonAction(_ sender: UIButton) {
        self.view.endEditing(true)
        self.dismiss(animated: true) {
            self.delegate?.handleDismissEndAudienceLiveStream()
        }
    }
    
    // Go Live Button Action
    @IBAction func goLiveButtonAction(_ sender: UIButton) {
        self.view.endEditing(true)
        self.dismiss(animated: true) {
            self.delegate?.handleGoLiveButtonAction()
        }
    }
    
    // MARK: - Helper Functions
    
    // Initial Config
    func initialConfig() {
        self.setData()
    }
    
    // Set Data
    func setData() {
        let userImage = URL(string: self.videoDetail?.owner?.avatar ?? "")
        self.userImageView.sd_setShowActivityIndicatorView(true)
        self.userImageView.sd_setIndicatorStyle(.medium)
        DispatchQueue.global(qos: .userInteractive).async {
            self.userImageView.sd_setImage(with: userImage, placeholderImage: R.image.maxresdefault())
        }
    }
    
}
