//
//  EndLiveStreamVC.swift
//  Playtube
//
//  Created by Muhammad's Macbook pro on 26/03/2021.
//  Copyright © 2021 Muhammad Haris Butt. All rights reserved.
//

import UIKit

protocol EndLiveStreamVCDelegate {
    func handleDismissLiveStream()
}

class EndLiveStreamVC: UIViewController {
    
    // MARK: - IBOutlets
    
    @IBOutlet weak var commentLabel: UILabel!
    @IBOutlet weak var viewsLabel: UILabel!
    @IBOutlet weak var durationLabel: UILabel!
    
    // MARK: - Properties
    
    var commnet: String?
    var views: String?
    var duration: String?
    var delegate: EndLiveStreamVCDelegate?
    
    // MARK: - View Life Cycles
    
    override func viewDidLoad() {
        super.viewDidLoad()
        
        self.initialConfig()
    }
    
    // MARK: - Selectors
    
    // Close Button Action
    @IBAction func closeButtonAction(_ sender: UIButton) {
        self.view.endEditing(true)
        self.dismiss(animated: true) {
            self.delegate?.handleDismissLiveStream()
        }
    }
    
    // MARK: - Helper Functions
    
    // Initial Config
    func initialConfig() {
        self.setData()
    }
    
    // Set Data
    func setData() {
        self.commentLabel.text = self.commnet
        self.viewsLabel.text = self.views
        self.durationLabel.text = self.duration
    }
    
}
