import UIKit
import Async
import PlaytubeSDK
import Toast_Swift

class ChangePasswordVC: BaseVC {
    
    // MARK: - IBOutlets
    
    @IBOutlet weak var repeatPasswordTextField: UITextField!
    @IBOutlet weak var newPasswordTextField: UITextField!
    @IBOutlet weak var currentPasswordTextField: UITextField!
    
    // MARK: - View Life Cycles
    
    override func viewDidLoad() {
        super.viewDidLoad()
        
    }
    
    // MARK: - Selectors
    
    // Back Button Action
    @IBAction func backButtonAction(_ sender: UIButton) {
        self.view.endEditing(true)
        self.navigationController?.popViewController(animated: true)
    }
    
    // Update Button Action
    @IBAction func updateButtonAction(_ sender: UIButton) {
        if (self.currentPasswordTextField.text?.isEmpty ?? false) {
            if let securityAlertVC = R.storyboard.popups.securityPopupVC() {
                securityAlertVC.titleText  = NSLocalizedString("Security", comment: "Security")
                securityAlertVC.errorText = NSLocalizedString("Please enter current password.", comment: "Please enter current password.")
                self.present(securityAlertVC, animated: true, completion: nil)
            }
        } else if (self.newPasswordTextField.text?.isEmpty ?? false) {
            if let securityAlertVC = R.storyboard.popups.securityPopupVC() {
                securityAlertVC.titleText  = NSLocalizedString("Security", comment: "Security")
                securityAlertVC.errorText = NSLocalizedString("Please enter new password.", comment: "Please enter new password.")
                self.present(securityAlertVC, animated: true, completion: nil)
            }
        } else if (self.repeatPasswordTextField.text?.isEmpty ?? false) {
            if let securityAlertVC = R.storyboard.popups.securityPopupVC() {
                securityAlertVC.titleText  = NSLocalizedString("Security", comment: "Security")
                securityAlertVC.errorText = NSLocalizedString("Please enter confirm password.", comment: "Please enter confirm password.")
                self.present(securityAlertVC, animated: true, completion: nil)
            }
        } else {
            self.showProgressDialog(text: NSLocalizedString("Loading...", comment: "Loading..."))
            let currentPass = self.currentPasswordTextField.text ?? ""
            let newPass = self.newPasswordTextField.text ?? ""
            let repeatPass = self.repeatPasswordTextField.text  ?? ""
            let userID = AppInstance.instance.userId ?? 0
            let sessionID = AppInstance.instance.sessionId ?? ""
            Async.background {
                MyChannelManager.instance.changePassword(User_id: userID, Session_Token: sessionID, CurrentPassword: currentPass, NewPassword: newPass, RepeatPassword: repeatPass, completionBlock: { (success, sessionError, error) in
                    if success != nil {
                        Async.main {
                            self.dismissProgressDialog {
                                log.debug("success = \(success?.message ?? "")")
                                self.view.makeToast(success?.message)
                            }
                        }
                    } else if sessionError != nil {
                        Async.main {
                            self.dismissProgressDialog {
                                log.error("error = \(sessionError?.errors?.error_text ?? "")")
                                self.view.makeToast(sessionError?.errors?.error_text)
                            }
                        }
                    } else {
                        Async.main {
                            self.dismissProgressDialog {
                                log.error("error = \(error?.localizedDescription ?? "")")
                                self.view.makeToast(error?.localizedDescription)
                            }
                        }
                    }
                })
            }
        }
    }
    
}
