//
//  AgeRestrictionPopupVC.swift
//  Playtube
//
//  Created by iMac on 12/12/23.
//  Copyright © 2023 ScriptSun. All rights reserved.
//

import UIKit

protocol AgeRestrictionPopupVCDelegate {
    func handleAgeRestrictionTap(ageRestriction: Int)
}

class AgeRestrictionPopupVC: UIViewController {

    // MARK: - Properties
    
    var delegate: AgeRestrictionPopupVCDelegate?
    
    // MARK: - View Life Cycles
    
    override func viewDidLoad() {
        super.viewDidLoad()
        
        self.initialConfig()
    }
    
    // MARK: - Selectors
    
    // All Age Button Action
    @IBAction func allAgeButtonAction(_ sender: UIButton) {
        self.view.endEditing(true)
        self.dismiss(animated: true) {
            self.delegate?.handleAgeRestrictionTap(ageRestriction: 1)
        }
    }
    
    // Only 18 Plus Button Action
    @IBAction func only18PlusButtonAction(_ sender: UIButton) {
        self.view.endEditing(true)
        self.dismiss(animated: true) {
            self.delegate?.handleAgeRestrictionTap(ageRestriction: 2)
        }
    }
    
    // Close Button Action
    @IBAction func closeButtonAction(_ sender: UIButton) {
        self.view.endEditing(true)
        self.dismiss(animated: true, completion: nil)
    }
    
    // MARK: - Helper Functions
    
    // Initial Config
    func initialConfig() {
        self.view.backgroundColor = .black.withAlphaComponent(0.4)
    }

}
