//
//  ImageAlertVC.swift
//  WoWonder
//
//  Created by iMac on 24/08/23.
//  Copyright © 2023 ScriptSun. All rights reserved.
//

import UIKit

enum ImagePickerSourceType {
    case CAMERA
    case PHOTO_LIBRARY
}

protocol ImageAlertVCDelegate {
    func handleImageGalleryTap(_ sender: UIButton)
    func handleTakePictureFromCameraTap(_ sender: UIButton)
}

class ImageAlertVC: UIViewController {
    
    // MARK: - Properties
    
    var delegate: ImageAlertVCDelegate?
    
    // MARK: - View Life Cycles

    override func viewDidLoad() {
        super.viewDidLoad()

        // Do any additional setup after loading the view.
        
        self.initialConfig()
    }
    
    //MARK: - Selectors
    
    // Take Picture Button Action
    @IBAction func takePictureButtonAction(_ sender: UIButton) {
        self.view.endEditing(true)
        self.dismiss(animated: true) {
            self.delegate?.handleTakePictureFromCameraTap(sender)
        }
    }
    
    // Image Gallery Button Action
    @IBAction func imageGalleryButtonAction(_ sender: UIButton) {
        self.view.endEditing(true)
        self.dismiss(animated: true) {
            self.delegate?.handleImageGalleryTap(sender)
        }
    }
    
    // Close Button Action
    @IBAction func closeButtonCLick(_ sender: UIButton) {
        self.view.endEditing(true)
        self.dismiss(animated: true)
    }
    
    // MARK: - Helper Functions
    
    // Initial Config
    func initialConfig() {
        self.view.backgroundColor = .black.withAlphaComponent(0.4)
    }
    
}
