//
//  LiveStreamPopupVC.swift
//  Playtube
//
//  Created by iMac on 30/01/24.
//  Copyright © 2024 ScriptSun. All rights reserved.
//

import UIKit

protocol LiveStreamPopupVCDelegate {
    func handleCopyButtonTap()
    func handleReportButtonTap()
}

class LiveStreamPopupVC: UIViewController {
    
    // MARK: - Properties
    
    var delegate: LiveStreamPopupVCDelegate?
    
    // MARK: - View Life Cycles
    
    override func viewDidLoad() {
        super.viewDidLoad()
        
        self.initialConfig()
    }
    
    // MARK: - Selectors
    
    // Copy Button Action
    @IBAction func copyButtonAction(_ sender: UIButton) {
        self.view.endEditing(true)
        self.dismiss(animated: true) {
            self.delegate?.handleCopyButtonTap()
        }
    }
    
    // Report Button Action
    @IBAction func reportButtonAction(_ sender: UIButton) {
        self.view.endEditing(true)
        self.dismiss(animated: true) {
            self.delegate?.handleReportButtonTap()
        }
    }
    
    // Close Button Action
    @IBAction func closeButtonAction(_ sender: UIButton) {
        self.view.endEditing(true)
        self.dismiss(animated: true, completion: nil)
    }
    
    // MARK: - Helper Functions
    
    // Initial Config
    func initialConfig() {
        self.view.backgroundColor = .black.withAlphaComponent(0.4)
    }
    
}

