//
//  LiveStreamReportPopupVC.swift
//  Playtube
//
//  Created by iMac on 30/01/24.
//  Copyright © 2024 ScriptSun. All rights reserved.
//

import UIKit

protocol LiveStreamReportPopupVCDelegate {
    func handleReportReportButtonTap()
}

class LiveStreamReportPopupVC: UIViewController {
    
    // MARK: - Properties
    
    var delegate: LiveStreamReportPopupVCDelegate?
    
    // MARK: - View Life Cycles
    
    override func viewDidLoad() {
        super.viewDidLoad()
        
        // Do any additional setup after loading the view.
        
        self.initialConfig()
    }
    
    // MARK: - Selectors
    
    // Cancel Button Action
    @IBAction func cancelButtonAction(_ sender: UIButton) {
        self.view.endEditing(true)
        self.dismiss(animated: true, completion: nil)
    }
    
    // Report Button Action
    @IBAction func reportButtonAction(_ sender: UIButton) {
        self.view.endEditing(true)
        self.dismiss(animated: true) {
            self.delegate?.handleReportReportButtonTap()
        }
    }
    
    // MARK: - Helper Functions
    
    // Initial Config
    func initialConfig() {
        self.view.backgroundColor = .black.withAlphaComponent(0.4)
    }
    
}

