import UIKit
import Async
import Toast_Swift

protocol PrivacyPopupVCDelegate {
    func handlePrivacyTap(privacy: Int)
}

class PrivacyPopupVC: BaseVC {
    
    // MARK: - Properties
    
    var delegate: PrivacyPopupVCDelegate?
    
    // MARK: - View Life Cycles
    
    override func viewDidLoad() {
        super.viewDidLoad()
        
        self.initialConfig()
    }
    
    // MARK: - Selectors
    
    // Public Button Action
    @IBAction func publicButtonAction(_ sender: UIButton) {
        self.view.endEditing(true)
        self.dismiss(animated: true) {
            self.delegate?.handlePrivacyTap(privacy: 0)
        }
    }
    
    // Private Button Action
    @IBAction func privateButtonAction(_ sender: UIButton) {
        self.view.endEditing(true)
        self.dismiss(animated: true) {
            self.delegate?.handlePrivacyTap(privacy: 1)
        }
    }
    
    // Unlisted Button Action
    @IBAction func unlistedButtonAction(_ sender: UIButton) {
        self.view.endEditing(true)
        self.dismiss(animated: true) {
            self.delegate?.handlePrivacyTap(privacy: 2)
        }
    }
    
    // Close Button Action
    @IBAction func closeButtonAction(_ sender: UIButton) {
        self.view.endEditing(true)
        self.dismiss(animated: true, completion: nil)
    }
    
    // MARK: - Helper Functions
    
    // Initial Config
    func initialConfig() {
        self.view.backgroundColor = .black.withAlphaComponent(0.4)
    }
    
}
