//
//  ProPurchaseAlertVC.swift
//  Playtube
//
//  Created by iMac on 06/01/24.
//  Copyright © 2024 ScriptSun. All rights reserved.
//

import UIKit

protocol ProPurchaseAlertVCDelegate {
    func handlePurchaseTap(purchaseFrom: String)
}

class ProPurchaseAlertVC: UIViewController {
    
    // MARK: - Properties
    
    var delegate: ProPurchaseAlertVCDelegate!
    
    // MARK: - View Life Cycles
    
    override func viewDidLoad() {
        super.viewDidLoad()
        
        // Do any additional setup after loading the view.
        
        self.initialConfig()
    }
    
    // MARK: - Selectors
    
    // InApp Button Action
    @IBAction func inAppButtonAction(_ sender: UIButton) {
        self.view.endEditing(true)
        self.dismiss(animated: true) {
            self.delegate.handlePurchaseTap(purchaseFrom: "InApp")
        }
    }
    
    // Wallet Button Action
    @IBAction func walletButtonAction(_ sender: UIButton) {
        self.view.endEditing(true)
        self.dismiss(animated: true) {
            self.delegate.handlePurchaseTap(purchaseFrom: "Wallet")
        }
    }
    
    // Close Button Action
    @IBAction func closeButtonAction(_ sender: UIButton) {
        self.view.endEditing(true)
        self.dismiss(animated: true, completion: nil)
    }
    
    // MARK: - Helper Functions
    
    // Initial Config
    func initialConfig() {
        self.view.backgroundColor = .black.withAlphaComponent(0.4)
    }
    
}

