//
//  ReportCopyrightPopupVC.swift
//  Playtube
//
//  Created by iMac on 29/08/23.
//  Copyright © 2023 ScriptSun. All rights reserved.
//

import UIKit
import PlaytubeSDK
import Async
import Toast_Swift

class ReportCopyrightPopupVC: BaseVC {
    
    @IBOutlet weak var messageTF: UITextView!
    
    var videoID: Int = 0
    var isCheckbox1 = false
    var isCheckbox2 = false
    var delegate: ReportVideoDelegate?
    
    override func viewDidLoad() {
        super.viewDidLoad()
        
        self.view.backgroundColor = .black.withAlphaComponent(0.4)
    }
    
    @IBAction func checkboxBtnAction(_ sender: UIButton) {
        self.view.endEditing(true)
        if sender.tag == 1001 {
            isCheckbox1 = !isCheckbox1
            let image = isCheckbox1 ? UIImage(named: "icon_checkmark") : nil
            sender.setImage(image, for: .normal)
        } else {
            isCheckbox2 = !isCheckbox2
            let image = isCheckbox2 ? UIImage(named: "icon_checkmark") : nil
            sender.setImage(image, for: .normal)
        }
    }
    
    @IBAction func cancelPressed(_ sender: UIButton) {
        self.view.endEditing(true)
        self.dismiss(animated: true, completion: nil)
    }
    
    @IBAction func submitPressed(_ sender: UIButton) {
        self.view.endEditing(true)
        if self.messageTF.text.trimmingCharacters(in: .whitespaces).count == 0 {
            self.view.makeToast("Please check Your details.")
            return
        }
        if (!self.isCheckbox1) {
            self.view.makeToast("Please select the checkboxs below if you own the copyright.")
            return
        }
        if (!self.isCheckbox2) {
            self.view.makeToast("Please select the checkboxs below if you own the copyright.")
            return
        }
        self.reportCopyrightVideo()
    }
    
    
    func reportCopyrightVideo() {
        if Connectivity.isConnectedToNetwork() {
            self.showProgressDialog(text: NSLocalizedString("Loading...", comment: "Loading..."))
            let userID = AppInstance.instance.userId ?? 0
            let sessionID = AppInstance.instance.sessionId ?? ""
            let videoID = self.videoID
            let reportText = self.messageTF.text ?? ""
            Async.background {
                ReportManager.instance.reportCopyrightVideo(User_id: userID, Session_Token: sessionID, id: videoID, text: reportText) { (success, sessionError, error) in
                    if success != nil {
                        Async.main {
                            self.dismissProgressDialog {
                                self.dismiss(animated: true, completion: {
                                    self.view.makeToast(success?.message)
                                    self.delegate?.reportVideo(true)
                                })
                            }
                        }
                    } else if sessionError != nil {
                        Async.main {
                            self.dismissProgressDialog {
                                log.error("responseError = \(sessionError?.errors!.error_text ?? "")")
                                self.view.makeToast(sessionError?.errors!.error_text)
                            }
                        }
                    } else {
                        self.dismissProgressDialog {
                            log.error("error = \(error?.localizedDescription ?? "")")
                            self.view.makeToast(error?.localizedDescription ?? "")
                        }
                    }
                }
            }
        } else {
            self.dismissProgressDialog {
                self.view.makeToast(InterNetError)
            }
        }
    }
    
}
