import Foundation

struct CheckLiveModel : Codable {
    
	let api_status : Int?
	let comments : [LiveComment]?
	let count : Int?
	let word : String?
	let still_live : String?
	let left : [Owner]?
	let joined : [Owner]?
	let api_version : String?

	enum CodingKeys: String, CodingKey {
		case api_status = "api_status"
		case comments = "comments"
		case count = "count"
		case word = "word"
		case still_live = "still_live"
		case left = "left"
		case joined = "joined"
		case api_version = "api_version"
	}

	init(from decoder: Decoder) throws {
		let values = try decoder.container(keyedBy: CodingKeys.self)
		api_status = try values.decodeIfPresent(Int.self, forKey: .api_status)
		comments = try values.decodeIfPresent([LiveComment].self, forKey: .comments)
		count = try values.decodeIfPresent(Int.self, forKey: .count)
		word = try values.decodeIfPresent(String.self, forKey: .word)
		still_live = try values.decodeIfPresent(String.self, forKey: .still_live)
		left = try values.decodeIfPresent([Owner].self, forKey: .left)
		joined = try values.decodeIfPresent([Owner].self, forKey: .joined)
		api_version = try values.decodeIfPresent(String.self, forKey: .api_version)
	}

}
