import Foundation

struct LiveComment : Codable {
    
	let id : Int?
	let user_id : Int?
	let video_id : Int?
	let post_id : Int?
	let activity_id : Int?
	let text : String?
	let time : Int?
	let pinned : String?
	let likes : Int?
	let dis_likes : Int?
	let user_data : Owner?

	enum CodingKeys: String, CodingKey {
		case id = "id"
		case user_id = "user_id"
		case video_id = "video_id"
		case post_id = "post_id"
		case activity_id = "activity_id"
		case text = "text"
		case time = "time"
		case pinned = "pinned"
		case likes = "likes"
		case dis_likes = "dis_likes"
		case user_data = "user_data"
	}

	init(from decoder: Decoder) throws {
		let values = try decoder.container(keyedBy: CodingKeys.self)
		id = try values.decodeIfPresent(Int.self, forKey: .id)
		user_id = try values.decodeIfPresent(Int.self, forKey: .user_id)
		video_id = try values.decodeIfPresent(Int.self, forKey: .video_id)
		post_id = try values.decodeIfPresent(Int.self, forKey: .post_id)
		activity_id = try values.decodeIfPresent(Int.self, forKey: .activity_id)
		text = try values.decodeIfPresent(String.self, forKey: .text)
		time = try values.decodeIfPresent(Int.self, forKey: .time)
		pinned = try values.decodeIfPresent(String.self, forKey: .pinned)
		likes = try values.decodeIfPresent(Int.self, forKey: .likes)
		dis_likes = try values.decodeIfPresent(Int.self, forKey: .dis_likes)
		user_data = try values.decodeIfPresent(Owner.self, forKey: .user_data)
	}

}
